<?php


  /* vim: set expandtab tabstop=4 softtabstop=4 shiftwidth=4:
  Codificación: UTF-8
  +----------------------------------------------------------------------+
  | Elastix version 2.0.2                                               |
  | http://www.elastix.org                                               |
  +----------------------------------------------------------------------+
  +----------------------------------------------------------------------+
  | The contents of this file are subject to the General Public License  |
  | (GPL) Version 2 (the "License"); you may not use this file except in |
  | compliance with the License. You may obtain a copy of the License at |
  | http://www.opensource.org/licenses/gpl-license.php                   |
  |                                                                      |
  | Software distributed under the License is distributed on an "AS IS"  |
  | basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See  |
  | the License for the specific language governing rights and           |
  | limitations under the License.                                       |
  +----------------------------------------------------------------------+
  | Developed by Haamed Kouhfallah, k.haamed@gmail.com                   |
  +----------------------------------------------------------------------+
   */
// ini_set("display_errors",1) ;
// error_reporting(-1);

//include elastix framework
include_once "libs/paloSantoGrid.class.php";
include_once "libs/paloSantoForm.class.php";
include_once "libs/paloSantoDB.class.php";
include_once("libs/paloSantoConfig.class.php");
	$arrDataExt = array();
//lite or pro	
define('LICENSE', 'pro');


function _moduleContent(&$smarty, $module_name)
{

    include_once("libs/paloSantoConfig.class.php");
//include_once "libs/paloSantoDB.class.php";
	
    //include module files
    include_once "modules/$module_name/configs/default.conf.php";
    include_once "modules/$module_name/libs/paloSantoPortService.class.php";

    //include file language agree to elastix configuration
    //if file language not exists, then include language by default (en)
    $lang=get_language();
    $base_dir=dirname($_SERVER['SCRIPT_FILENAME']);
    $lang_file="modules/$module_name/lang/$lang.lang";
    if (file_exists("$base_dir/$lang_file")) include_once "$lang_file";
    else include_once "modules/$module_name/lang/en.lang";

    //global variables
    global $arrConf;
    global $arrConfModule;
    global $arrLang;
    global $arrLangModule;
	//global $smartfinkPermisionsCount = "8";
    $arrConf = array_merge($arrConf,$arrConfModule);
    $arrLang = array_merge($arrLang,$arrLangModule);

    //folder path for custom templates
    $templates_dir=(isset($arrConf['templates_dir']))?$arrConf['templates_dir']:'themes';
    $local_templates_dir="$base_dir/modules/$module_name/".$templates_dir.'/'.$arrConf['theme'];

    //conexion
    $pDB = new paloDB($arrConf['dsn_conn_database']);

	
	//Limited Propmt
	//Free
	if(LICENSE == 'lite')
	$smarty->assign('mb_message', "<b>"."In SmartFink Lite Edition, You Will See Less Information. "."</b>"."&nbsp;<a href='http://www.smartfink.com'>"." See More Info"."</a>");

		//Get Extensions List
	/*******/
	global $arrDataExt;
    $pConfig = new paloConfig("/etc", "amportal.conf", "=", "[[:space:]]*=[[:space:]]*");
    $arrConfig = $pConfig->leer_configuracion(false);

    $dsn = $arrConfig['AMPDBENGINE']['valor'] . "://" . $arrConfig['AMPDBUSER']['valor'] . ":" . $arrConfig['AMPDBPASS']['valor'] . "@" . $arrConfig['AMPDBHOST']['valor'] . "/asterisk";
    $pDBa     = new paloDB($dsn);
    $sQuery="select extension from users order by extension;";
    $arrayResult = $pDBa->fetchTable($sQuery,true);
	
    if (!$arrayResult){
        $error = $pDBa->errMsg;
    }else{

        if (is_array($arrayResult) && count($arrayResult)>0) {
            //$arrDataExt[$item["null"]] = "No extension";
            // if($idUserAccount){
			    //$arrDataExt[""] = $arrLang["no extension"];
                foreach($arrayResult as $item) {
                    $arrDataExt[$item["extension"]] = $item["extension"];
					 //echo $arrDataExt[$item["extension"]]."<br>";
                }
        }
	}
			// //Write to file
		// $file = fopen("/tmp/test.txt","w");
		// fwrite($file,"BIB:".$pConfig."\r\n"."Error:".$error."\r\n"."DSN:".$dsn."\n\r"."Result:".count($arrayResult));
		// fclose($file);
	
    //actions
    $accion = getAction();
    $content = "";

    switch($accion){
        case 'save':
            $content = savePuerto($smarty, $module_name, $local_templates_dir, $pDB, $arrConf);
            break;
        case 'new': case 'view': case 'edit':
            $content = NewViewPuerto($smarty, $module_name, $local_templates_dir, $pDB, $arrConf, $accion);
            break;
        case 'delete':
            $content = deletePuertos($smarty, $module_name, $local_templates_dir, $pDB, $arrConf);
            break;
        case 'cancel':
            $content = reportPuertos($smarty, $module_name, $local_templates_dir, $pDB, $arrConf);
            break;
        default:
            $content = reportPuertos($smarty, $module_name, $local_templates_dir, $pDB, $arrConf);
            break;
    }
    return $content;

}

function deleteSmartfinkPermisions($extension)
{
		
	$st = "asterisk -rx \"database deltree smartfink/$extension \" 2>&1";
	$results = shell_exec($st);

	return ($results);
}

function setSmartfinkPermisions($string)
{

	$string = explode(",", $string);
	$extension = $string[0];
	foreach($string as $key => $value){
	if($key == "1"){
	$st = "asterisk -rx \"database put smartfink $extension/01Password $value\" 2>&1";
	$results = shell_exec($st);
	}
	if($key == "2"){
	$st = "asterisk -rx \"database put smartfink $extension/02PanelExt $value\" 2>&1";
	$results = shell_exec($st);
	}
	if($key == "3"){
	$st = "asterisk -rx \"database put smartfink $extension/03PanelQueue $value\" 2>&1";
	$results = shell_exec($st);
	}
	if($key == "4"){
	$st = "asterisk -rx \"database put smartfink $extension/04PanelDAHDI $value\" 2>&1";
	$results = shell_exec($st);
	}
	if($key == "5"){
	$st = "asterisk -rx \"database put smartfink $extension/05ExtRecord $value\" 2>&1";
	$results = shell_exec($st);
	}
	if($key == "6"){
	$st = "asterisk -rx \"database put smartfink $extension/06ExtBarge $value\" 2>&1";
	$results = shell_exec($st);
	}
	if($key == "7"){
	$st = "asterisk -rx \"database put smartfink $extension/07ExtWhisper $value\" 2>&1";
	$results = shell_exec($st);
	}
	if($key == "8"){
	$st = "asterisk -rx \"database put smartfink $extension/08ExtDial $value\" 2>&1";
	$results = shell_exec($st);
	}
	if($key == "9"){
	$st = "asterisk -rx \"database put smartfink $extension/09ExtDrag $value\" 2>&1";
	$results = shell_exec($st);
	}
	if($key == "10"){
	$st = "asterisk -rx \"database put smartfink $extension/10QueueEntDrag $value\" 2>&1";
	$results = shell_exec($st);
	}
	if($key == "11"){
	$st = "asterisk -rx \"database put smartfink $extension/11QueueMemPause $value\" 2>&1";
	$results = shell_exec($st);
	}
	if($key == "12"){
	$st = "asterisk -rx \"database put smartfink $extension/12DND $value\" 2>&1";
	$results = shell_exec($st);
	}
	
	}
	return ($results);
}

function getSmartfinkPermisionsByExt($extension)
{


		$pre = "asterisk -rx \"database show smartfink $extension\" 2>&1";
		$results = shell_exec($pre);
		
		// //Write to file
		 //$file = fopen("/tmp/nin.txt","w");
		//fwrite($file,$results."#".$extension);
		 //fclose($file);
		
		$results = explode("\n", $results);
		if($results[0] != ""){
			
		
				foreach($results as $key => $value){
						$tmpResults = explode("/", $results[$key]);
						if(isset($tmpResults[2]))
						$user = trim($tmpResults[2]);
						//Check if User name is Numeric and it is not empty
						if($user != null && $user != "" && is_numeric($user)){
								if(isset($tmpResults[3]))
									$permision = explode(":", $tmpResults[3]);
								if(isset($tmpResults[0]))
									$permisionName = trim($permision[0]);
								if(isset($tmpResults[1]))
									$permision = trim($permision[1]);
							if($tempUser != $user){
								$line =  $user.",".$permision;
								$tempUser = $user;
							}
							else if ($tempUser == $user)
								$line =  $line.",".$permision;
							
							}
			}
      }
	return ($line);
}

function getSmartfinkPermisions()
{
	//full
	//if(LICENSE == 'pro')
	//$st = "asterisk -rx \"database put smartfink version/version 1\" 2>&1";
	//if(LICENSE == 'lite')
	//$st = "asterisk -rx \"database put smartfink version/version 0\" 2>&1";
	//$results = shell_exec($st);

	$results = shell_exec('asterisk -rx "database show smartfink" 2>&1');
	$results = explode("\n", $results);

	$tempUser = "";
	$tmpResults = array();
	$line = "";
	$arrResult = "";	
	
			$file = fopen("/tmp/result.txt","w");
		  fwrite($file,"0:".$results[0]."\r\n"."1:".$results[1]."\r\n"."2:".$results[0]);
		  fclose($file);
		  
			if($results[1] != "" && !(strpos($results[1], 'Privilege') !== FALSE) && !(strpos($results[0], 'license') !== FALSE)){
			
			
						$file = fopen("/tmp/result8.txt","w");
		  fwrite($file,"0:".$results[0]."\r\n"."1:".$results[1]."\r\n"."2:".$results[2]);
		  fclose($file);
			
			foreach($results as $key => $value){
						$tmpResults = explode("/", $results[$key]);
						// $user = trim($tmpResults[2]);
						// if($user != null && $user != ""){
						if(isset($tmpResults[2])) $user = trim($tmpResults[2]);
						//Check if User name is Numeric and it is not empty
						if(isset($user) && $user != null && $user != "" && is_numeric($user)){
							if(isset($tmpResults[3]))
							$permision = explode(":", $tmpResults[3]);
							if(isset($permision[0]))
							$permisionName = trim($permision[0]);
							if(isset($permision[1]))
							$permision = trim($permision[1]);
							if($tempUser != $user){
								$line =  $line.";".$user.",".$permision;
								$tempUser = $user;
							}
							else if ($tempUser == $user)
								$line =  $line.",".$permision;
							
							}
	}


    $arrResult = explode(";", substr($line, 1));
       }
	return ($arrResult);
}

function reportPuertos($smarty, $module_name, $local_templates_dir, &$pDB, $arrConf)
{

    $pPuertos = new paloSantoPortService($pDB);

    $field_type = getParameter("filter_type");
    $field_pattern = getParameter("filter_txt");
    //begin grid parameters
    $oGrid  = new paloSantoGrid($smarty);
    $oGrid->addNew("new",_tr("Define Port"));
    $oGrid->deleteList("Are you sure you wish to delete the user(s).?","delete",_tr("Delete"));

    //$totalPuertos = $pPuertos->ObtainNumPuertos($field_type, $field_pattern);

	$arrResult = getSmartfinkPermisions();
	
    $limit  = 40;
    $total  = count($arrResult);
    $oGrid->setLimit($limit);
    $oGrid->setTotal($total);
    $oGrid->setTitle(_tr("Define Ports"));
    $oGrid->setIcon("modules/$module_name/images/security_define_ports.png");
    $oGrid->pagingShow(true);
    //$offset = $oGrid->calculateOffset();
    $url = array(
        "menu"         =>  $module_name,
        "filter_type"  =>  $field_type,
        "filter_txt"   =>  $field_pattern
    );    
    $oGrid->setURL($url);

    $arrData = null;
    //$arrResult = $pPuertos->ObtainPuertos($limit, $offset, $field_type, $field_pattern);

    $button_eliminar = "";
	//Changed By Haamed
    $arrColumns = array($button_eliminar,_tr("Extension"),_tr("Password"),_tr("Ext Panel"),_tr("Queue Panel"),_tr("DAHDI Panel"),_tr("Record"),_tr("Barge"),_tr("Whisper"),_tr("Dial"),_tr("Ext Drag"),_tr("Queue Ent Drag"),_tr("Queue Mem Pause"),_tr("DND"),_tr("Edit"));
    $oGrid->setColumns($arrColumns);
    if( is_array($arrResult) && $total>0 ){
        foreach($arrResult as $key => $value){
				$arrResultTemp = explode(",", $arrResult[$key]);
				//Extension
				$temp = "<input type='checkbox' name=$arrResultTemp[0]>";
			$arrTmp[0] = $temp;
				
		 
			 if (isset($arrResultTemp[0])) $arrTmp[1] = $arrResultTemp[0];
			 if (isset($arrResultTemp[1])) $arrTmp[2] = $arrResultTemp[1];
			 if (isset($arrResultTemp[2])) $arrTmp[3] = $arrResultTemp[2];
			 if (isset($arrResultTemp[3])) $arrTmp[4] = $arrResultTemp[3];
			 if (isset($arrResultTemp[4])) $arrTmp[5] = $arrResultTemp[4];
			 if (isset($arrResultTemp[5])) $arrTmp[6] = $arrResultTemp[5];
			 if (isset($arrResultTemp[6])) $arrTmp[7] = $arrResultTemp[6];
			 if (isset($arrResultTemp[7])) $arrTmp[8] = $arrResultTemp[7];
			 if (isset($arrResultTemp[8])) $arrTmp[9] = $arrResultTemp[8];
			 if (isset($arrResultTemp[9])) $arrTmp[10] = $arrResultTemp[9];
			 if (isset($arrResultTemp[10])) $arrTmp[11] = $arrResultTemp[10];
			 if (isset($arrResultTemp[11])) $arrTmp[12] = $arrResultTemp[11];
			 //DND
			 if (isset($arrResultTemp[12])) $arrTmp[13] = $arrResultTemp[12];
			// if (isset($arrResultTemp[12])) $arrTmp[13] = $arrResultTemp[12];
			 
			 $arrTmp[14] = "&nbsp;<a href='?menu=$module_name&action=view&extension=".$arrResultTemp[0]."'>"._tr('View')."</a>";
	 
			 //$arrTmp[12] = "&nbsp;<a href='?menu=$module_name&action=save'>"._tr('View')."</a>";
			 
			        foreach($arrTmp as $key => $value){
					if($arrTmp[$key] == "1")
					$arrTmp[$key] = 'Yes';
					else if ($arrTmp[$key] == "0")
					$arrTmp[$key] = 'No';
					}
			$arrData[] = $arrTmp;
        }
    }
    $oGrid->setData($arrData);
    //begin section filter
    //$arrFormFilterPuertos = createFieldForm();
    //$oFilterForm = new paloForm($smarty, $arrFormFilterPuertos);
    $smarty->assign("SHOW", _tr("Show"));

    $_POST["filter_type"]  = $field_type;
    $_POST["filter_txt"] = $field_pattern;

    if(is_null($field_type) || $field_type==""){
        $nameFieldType = "";
    }else{
        $nameFieldType = $arrFormFilterPuertos["filter_type"]["INPUT_EXTRA_PARAM"][$field_type];
    }

    $oGrid->addFilterControl(_tr("Filter applied: ").$nameFieldType." = ".$field_pattern,$_POST, array("filter_type" => "name","filter_txt" => "x"));

    //$htmlFilter = $oFilterForm->fetchForm("$local_templates_dir/filter.tpl","",$_POST);
    //end section filter

    //$oGrid->showFilter(trim($htmlFilter));
    $contenidoModulo = $oGrid->fetchGrid();
    if (strpos($contenidoModulo, '<form') === FALSE)
        $contenidoModulo = "<form  method='POST' style='margin-bottom:0;' action=$url>$contenidoModulo</form>";
    //end grid parameters

    return $contenidoModulo;
}

function createFieldForm()
{
    $arrType = array("name" => _tr("Name"), "protocol" => _tr("Protocol"));

 
    $arrFormElements = array(
            "filter_type"  => array(   "LABEL"                  => _tr("Search"),
                                       "REQUIRED"               => "no",
                                       "INPUT_TYPE"             => "SELECT",
                                       "INPUT_EXTRA_PARAM"      => $arrType,
                                       "VALIDATION_TYPE"        => "text",
                                       "VALIDATION_EXTRA_PARAM" => ""),
            "filter_txt"   => array(   "LABEL"                  => "",
                                       "REQUIRED"               => "no",
                                       "INPUT_TYPE"             => "TEXT",
                                       "INPUT_EXTRA_PARAM"      => array("id" => "filter_value"),
                                       "VALIDATION_TYPE"        => "text",
                                       "VALIDATION_EXTRA_PARAM" => ""),
                    );
    return $arrFormElements;
}

function NewViewPuerto($smarty, $module_name, $local_templates_dir, &$pDB, $arrConf, $action)
{
    $arrFormNew = createFieldFormNew();
    $oForm = new paloForm($smarty, $arrFormNew);
    $titulo = "";
    $smarty->assign("CANCEL", _tr("Cancel"));
    $smarty->assign("REQUIRED_FIELD", _tr("Required field"));
    $smarty->assign("icon", "images/list.png");
    $protocol = getParameter("protocol");
	$id = "";

    if( $action == 'new' )
    {
        $smarty->assign("SAVE", _tr("Save"));
        /*if($protocol=="ICMP"){        
            $smarty->assign("port_style", "style = 'display:none;'");
            $smarty->assign("protocol_style", "style = 'display:none;'");
        }elseif($protocol=="IP"){
            $smarty->assign("port_style", "style = 'display:none;'");
            $smarty->assign("type_style", "style = 'display:none;'");
            $smarty->assign("code_style", "style = 'display:none;'");
        }else{
            $smarty->assign("protocol_style", "style = 'display:none;'");
            $smarty->assign("type_style", "style = 'display:none;'");
            $smarty->assign("code_style", "style = 'display:none;'");
        }*/
        $titulo = _tr('Define Port');
    }
    else if( $action == 'edit' )
    {
		$extension = $_POST['idtemp'];
		$_POST['extension'] = $_POST['idtemp'];
		
		$permission = getSmartfinkPermisionsByExt($extension);
		$arrResultTemp = explode(",", $permission);
	
    $_POST['password'] = $arrResultTemp[1];
	if($arrResultTemp[2] == "1")
    $_POST['panelext'] = "Yes";
	else $_POST['panelext'] = "No";
		if($arrResultTemp[3] == "1")
    $_POST['panelqueue'] = "Yes";
	else $_POST['panelqueue'] = "No";
		if($arrResultTemp[4] == "1")
    $_POST['paneldahdi'] = "Yes";
	else $_POST['paneldahdi'] = "No";
		if($arrResultTemp[5] == "1")
    $_POST['extrecord'] = "Yes";
	else $_POST['extrecord'] = "No";
		if($arrResultTemp[6] == "1")
    $_POST['extbarge'] = "Yes";
	 else $_POST['extbarge'] = "No";
		if($arrResultTemp[7] == "1")
    $_POST['extwhisper'] = "Yes";
	else $_POST['extwhisper'] = "No";
		if($arrResultTemp[8] == "1")
    $_POST['extdial'] = "Yes";
	else $_POST['extdial'] = "No";
		if($arrResultTemp[9] == "1")
    $_POST['extdrag'] = "Yes";
	else $_POST['extdrag'] = "No";
		if($arrResultTemp[10] == "1")
    $_POST['queueentdrag'] = "Yes";
	else $_POST['queueentdrag'] = "No";
		if($arrResultTemp[11] == "1")
    $_POST['queuemempause'] = "Yes";
	else $_POST['queuemempause'] = "No";
	if($arrResultTemp[12] == "1")
    $_POST['dnd'] = "Yes";
	else $_POST['dnd'] = "No";
		
	//$_POST['password'] = $_POST['idtemp'];
		//$_POST['panelext'] = "No";
        //$id = $_POST['idtemp'];
		
			//$file = fopen("/tmp/result55.txt","w");
		  //fwrite($file,$arrResultTemp[1]."#".$arrResultTemp[0]);
		  //fclose($file);	
		
        $smarty->assign("IDTEMP", $id);
        $smarty->assign("SAVE", _tr("Save"));

        //$oPalo = new paloSantoPortService($pDB);
        //$result = $oPalo->loadPuerto($id);

        $smarty->assign("EDIT", _tr("Edit"));
        $smarty->assign("IDTEMP", $id);

       $_POST['extension'] = $extension;
		if(isset($result['comment']))
        $_POST['comment'] = $result['comment'];
        
        $titulo = _tr('Edit Port');
    }
    else if( $action == 'view' )
    {


	
	    //$id = $_GET['id'];
		$extension = $_GET['extension'];
		$smarty->assign("extid", $extension);
        //$oPalo = new paloSantoPortService($pDB);
        //$result = $oPalo->loadPuerto($id);

         $smarty->assign("EDIT", _tr("Edit"));
         $smarty->assign("IDTEMP", $extension);

        $oForm->setViewMode();
        $titulo = _tr('View Port');

		
		$permission = getSmartfinkPermisionsByExt($extension);

		$arrResultTemp = explode(",", $permission);
		
				$file = fopen("/tmp/result44.txt","w");
		  fwrite($file,$extension."#".$arrResultTemp[0]);
		  fclose($file);
		

    $_POST['extension'] = $arrResultTemp[0];
    $_POST['password'] = $arrResultTemp[1];
	if($arrResultTemp[2] == "1")
    $_POST['panelext'] = "Yes";
	else $_POST['panelext'] = "No";
		if($arrResultTemp[3] == "1")
    $_POST['panelqueue'] = "Yes";
	else $_POST['panelqueue'] = "No";
		if($arrResultTemp[4] == "1")
    $_POST['paneldahdi'] = "Yes";
	else $_POST['paneldahdi'] = "No";
		if($arrResultTemp[5] == "1")
    $_POST['extrecord'] = "Yes";
	else $_POST['extrecord'] = "No";
		if($arrResultTemp[6] == "1")
    $_POST['extbarge'] = "Yes";
	 else $_POST['extbarge'] = "No";
		if($arrResultTemp[7] == "1")
    $_POST['extwhisper'] = "Yes";
	else $_POST['extwhisper'] = "No";
		if($arrResultTemp[8] == "1")
    $_POST['extdial'] = "Yes";
	else $_POST['extdial'] = "No";
		if($arrResultTemp[9] == "1")
    $_POST['extdrag'] = "Yes";
	else $_POST['extdrag'] = "No";
		if($arrResultTemp[10] == "1")
    $_POST['queueentdrag'] = "Yes";
	else $_POST['queueentdrag'] = "No";
		if($arrResultTemp[11] == "1")
    $_POST['queuemempause'] = "Yes";
	else $_POST['queuemempause'] = "No";
			if($arrResultTemp[12] == "1")
    $_POST['dnd'] = "Yes";
	else $_POST['dnd'] = "No";
			
    }
    
    $smarty->assign("MODE", $action);

    $htmlForm = $oForm->fetchForm("$local_templates_dir/form.tpl", $titulo, $_POST);
    $contenidoModulo = "<form  method='POST' style='margin-bottom:0;' action='?menu=$module_name'>".$htmlForm."</form>";

    return $contenidoModulo;
}

function createFieldFormNew()
{
global $arrDataExt;
    $arrProtocols = array('Yes' => 'Yes', 'No' => 'No');

    $arrFields = array(
            // "extension"      => array(   "LABEL"                  => _tr("extension"),
                                    // "REQUIRED"               => "yes",
                                    // "INPUT_TYPE"             => "TEXT",
                                    // "INPUT_EXTRA_PARAM"      => array("style" => "width:162px"),
                                    // "VALIDATION_TYPE"        => "text",
                                    // "VALIDATION_EXTRA_PARAM" => "" ),
									                //Extensions List
				"extension"   => array("LABEL"                  => _tr("extension"),
                "REQUIRED"               => "yes",
                "INPUT_TYPE"             => "SELECT",
                 "INPUT_EXTRA_PARAM"      => $arrDataExt,
                 "VALIDATION_TYPE"        => "text",
                  "VALIDATION_EXTRA_PARAM" => ""),
			"password"      => array(   "LABEL"                  => _tr("password"),
                                    "REQUIRED"               => "yes",
                                    "INPUT_TYPE"             => "TEXT",
                                    "INPUT_EXTRA_PARAM"      => array("style" => "width:162px"),
                                    "VALIDATION_TYPE"        => "text",
                                    "VALIDATION_EXTRA_PARAM" => "" ),
            "panelext"  => array(   "LABEL"                  => _tr("Ext Panel"),
                                    "REQUIRED"               => "no",
                                    "INPUT_TYPE"             => "SELECT",
                                    "INPUT_EXTRA_PARAM"      => $arrProtocols,
                                    "VALIDATION_TYPE"        => "text",
                                    "VALIDATION_EXTRA_PARAM" => "",
                                    "ONCHANGE"               => "hideField(this.value)"),
            "panelqueue"  => array(   "LABEL"                  => _tr("Queue Panel"),
                                    "REQUIRED"               => "no",
                                    "INPUT_TYPE"             => "SELECT",
                                    "INPUT_EXTRA_PARAM"      => $arrProtocols,
                                    "VALIDATION_TYPE"        => "text",
                                    "VALIDATION_EXTRA_PARAM" => "",
                                    "ONCHANGE"               => "hideField(this.value)"),
            "paneldahdi"  => array(   "LABEL"                  => _tr("DAHDI Panel"),
                                    "REQUIRED"               => "no",
                                    "INPUT_TYPE"             => "SELECT",
                                    "INPUT_EXTRA_PARAM"      => $arrProtocols,
                                    "VALIDATION_TYPE"        => "text",
                                    "VALIDATION_EXTRA_PARAM" => "",
                                    "ONCHANGE"               => "hideField(this.value)"),
            "extrecord"  => array(   "LABEL"                  => _tr("Ext Record"),
                                    "REQUIRED"               => "no",
                                    "INPUT_TYPE"             => "SELECT",
                                    "INPUT_EXTRA_PARAM"      => $arrProtocols,
                                    "VALIDATION_TYPE"        => "text",
                                    "VALIDATION_EXTRA_PARAM" => "",
                                    "ONCHANGE"               => "hideField(this.value)"),
            "extbarge"  => array(   "LABEL"                  => _tr("Ext Barge"),
                                    "REQUIRED"               => "no",
                                    "INPUT_TYPE"             => "SELECT",
                                    "INPUT_EXTRA_PARAM"      => $arrProtocols,
                                    "VALIDATION_TYPE"        => "text",
                                    "VALIDATION_EXTRA_PARAM" => "",
                                    "ONCHANGE"               => "hideField(this.value)"),
            "extwhisper"  => array(   "LABEL"                  => _tr("Ext Whisper"),
                                    "REQUIRED"               => "no",
                                    "INPUT_TYPE"             => "SELECT",
                                    "INPUT_EXTRA_PARAM"      => $arrProtocols,
                                    "VALIDATION_TYPE"        => "text",
                                    "VALIDATION_EXTRA_PARAM" => "",
                                    "ONCHANGE"               => "hideField(this.value)"),
            "extdial"  => array(   "LABEL"                  => _tr("Ext Dial"),
                                    "REQUIRED"               => "no",
                                    "INPUT_TYPE"             => "SELECT",
                                    "INPUT_EXTRA_PARAM"      => $arrProtocols,
                                    "VALIDATION_TYPE"        => "text",
                                    "VALIDATION_EXTRA_PARAM" => "",
                                    "ONCHANGE"               => "hideField(this.value)"),
            "extdrag"  => array(   "LABEL"                  => _tr("Ext Drag"),
                                    "REQUIRED"               => "no",
                                    "INPUT_TYPE"             => "SELECT",
                                    "INPUT_EXTRA_PARAM"      => $arrProtocols,
                                    "VALIDATION_TYPE"        => "text",
                                    "VALIDATION_EXTRA_PARAM" => "",
                                    "ONCHANGE"               => "hideField(this.value)"),
            "queueentdrag"  => array(   "LABEL"                  => _tr("Queue Entry Drag"),
                                    "REQUIRED"               => "no",
                                    "INPUT_TYPE"             => "SELECT",
                                    "INPUT_EXTRA_PARAM"      => $arrProtocols,
                                    "VALIDATION_TYPE"        => "text",
                                    "VALIDATION_EXTRA_PARAM" => "",
                                    "ONCHANGE"               => "hideField(this.value)"),
            "queuemempause"  => array(   "LABEL"                  => _tr("Queue Member Pause"),
                                    "REQUIRED"               => "no",
                                    "INPUT_TYPE"             => "SELECT",
                                    "INPUT_EXTRA_PARAM"      => $arrProtocols,
                                    "VALIDATION_TYPE"        => "text",
                                    "VALIDATION_EXTRA_PARAM" => "",
                                    "ONCHANGE"               => "hideField(this.value)"),
			"dnd"  => array(   "LABEL"                  => _tr("DND"),
                                    "REQUIRED"               => "no",
                                    "INPUT_TYPE"             => "SELECT",
                                    "INPUT_EXTRA_PARAM"      => $arrProtocols,
                                    "VALIDATION_TYPE"        => "text",
                                    "VALIDATION_EXTRA_PARAM" => "",
                                    "ONCHANGE"               => "hideField(this.value)"),
            );

    return $arrFields;
}

function savePuerto($smarty, $module_name, $local_templates_dir, &$pDB, $arrConf)
{

    $arrFormNew = createFieldFormNew();
    $oForm      = new paloForm($smarty, $arrFormNew);
    $extension       = getParameter('extension');
    $password       = getParameter("password");
    $panelext   = getParameter("panelext");
    $panelqueue      = getParameter("panelqueue");
    $paneldahdi      = getParameter("paneldahdi");
    $extrecord       = getParameter("extrecord");
    $extbarge       = getParameter("extbarge");
    $extwhisper       = getParameter("extwhisper");
    $extdial = getParameter("extdial");
    $extdrag    = getParameter("extdrag");
    $queueentdrag  = getParameter("queueentdrag");
	$queuemempause    = getParameter("queuemempause");
	$dnd  = getParameter("dnd");
    $isError    = false;

	if($panelext == "Yes")
	$panelext = 1;
	else
	$panelext = 0;
	if($panelqueue == "Yes")
	$panelqueue = 1;
	else
	$$panelqueue = 0;
	if($paneldahdi == "Yes")
	$paneldahdi = 1;
	else
	$paneldahdi = 0;
	if($extrecord == "Yes")
	$extrecord = 1;
	else
	$extrecord = 0;
	if($extbarge == "Yes")
	$extbarge = 1;
	else
	$extbarge = 0;
	if($extwhisper == "Yes")
	$extwhisper = 1;
	else
	$extwhisper = 0;
	if($extdial == "Yes")
	$extdial = 1;
	else
	$extdial = 0;
	if($extdrag == "Yes")
	$extdrag = 1;
	else
	$extdrag = 0;
	if($queueentdrag == "Yes")
	$queueentdrag = 1;
	else
	$queueentdrag = 0;
	if($queuemempause == "Yes")
	$queuemempause = 1;
	else
	$queuemempause = 0;
	if($dnd == "Yes")
	$dnd = 1;
	else
	$dnd = 0;

				//$file = fopen("/tmp/result89.txt","w");
		  //fwrite($file,$password);
		  //fclose($file);

	
	
	if(trim($extension) == null || trim($extension) == ""){
				$msg .= "<br />"._tr("Error: Nothing Saved, You Can not enter Empty Extension Number");}
	else if(trim($password) == null || trim($password) == ""){
				$msg .= "<br />"._tr("Error: Nothing Saved, You Can not enter Empty Password");}
				
	else if( strlen(trim($password)) < 3 ) {
				$msg .= "<br />"._tr("Error: Password too short! at Least choose 3 characters");
		}

	else if( strlen(trim($password)) > 20 ) {
				$msg .= "<br />"._tr("Error: Password too long! at Last choose 20 characters");
		}
	elseif( preg_match('/[^A-Za-z0-9.!#*@$\\-$]/', $password) ) {
				$msg .= "<br />"._tr("Error: Password only contains valid characters: a-z, A-Z, 0-9, #,*, -, ., $,@,!");
		}
		
	else{
			$string = $extension. "," . $password. "," .$panelext. "," .$panelqueue. "," .$paneldahdi. "," .$extrecord. "," .$extbarge. "," .$extwhisper. "," .$extdial. "," .$extdrag. "," .$queueentdrag. "," .$queuemempause. "," .$dnd;
			$setResult = setSmartfinkPermisions($string);
			//Get The first row of Message
			$setResult = explode("\n", $setResult);
			$setResult = $setResult[0];
			$msg = _tr($setResult);
	}
            $smarty->assign("mb_title", _tr("Message"));
            $smarty->assign("mb_message", $msg);

    return reportPuertos($smarty, $module_name, $local_templates_dir, $pDB, $arrConf);
}

function deletePuertos($smarty, $module_name, $local_templates_dir, &$pDB, $arrConf)
{
    //$oPalo = new paloSantoPortService($pDB);
    $str_msj_error = "";

    foreach( $_POST as $key => $value ){
         if( $value == "on" ){
	    // $port = "";
	    // if(!$oPalo->isPortInService($key, $port)){
		// if( $oPalo->deletePuerto($key) == false )
		    // $str_msj_error .= $oPalo->errMsg."<br />";
	    // }
	    // else
		// $str_msj_error .= _tr("Port used in a firewall rule").": $port[name]. "._tr("You have to delete the rule related in order to delete this port")."<br />";
        
		$result = deleteSmartfinkPermisions($key);
		}
		
	$Handle = fopen("/tmp/delete.txt", 'a+');
    fwrite($Handle,$key.":".$value.":"."\t\n"); 
    fclose($Handle);
    }
	
    if( strlen($str_msj_error) == 0 ){
        $smarty->assign("mb_title", _tr("Message"));
        $smarty->assign("mb_message", _tr("Delete correctly"));
    }
    else{
        $smarty->assign("mb_title", _tr("ERROR"));
        $smarty->assign("mb_message", $str_msj_error);
    }

    return reportPuertos($smarty, $module_name, $local_templates_dir, $pDB, $arrConf);
}

function getAction()
{
    if(getParameter("show")) //Get parameter by POST (submit)
        return "show";
    if(getParameter("delete")) //Get parameter by POST (submit)
        return "delete";
    else if(getParameter("new"))
        return "new";
    else if(getParameter("save"))
        return "save";
    else if(getParameter("edit"))
        return "edit";
    else if(getParameter("cancel"))
        return "cancel";
    else if(getParameter("action")=="show") //Get parameter by GET (command pattern, links)
        return "show";
    else if(getParameter("action")=="view") //Get parameter by GET (command pattern, links)
        return "view";
    else
        return "report";
}
?>
